Index: LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2839)
@@ -41,6 +41,6 @@
 
     use mod_grid_phy_lmdz, ONLY : nbp_lat
-    use regr1_conserv_m, only: regr1_conserv
-    use regr3_lint_m, only: regr3_lint
+    use regr_conserv_m, only: regr_conserv
+    use regr_lint_m, only: regr_lint
     use netcdf95, only: nf95_open, nf95_close, nf95_inq_varid, handle_err, &
          nf95_put_var, nf95_gw_var
@@ -84,5 +84,5 @@
     ! Last dimension is month number.)
 
-    real, allocatable:: o3_par_out(:, :, :) ! (jjm + 1, n_plev, 360)
+    real, allocatable:: o3_par_out(:, :, :) ! (jjm + 1, n_plev, ndays)
     ! (regridded ozone parameter)
     ! ("o3_par_out(j, l, day)" is at latitude "rlatu(j)", pressure
@@ -162,5 +162,5 @@
     latitude = latitude / 180. * pi
     n_lat = size(latitude)
-    ! We need to supply the latitudes to "regr1_conserv" in
+    ! We need to supply the latitudes to "regr_conserv" in
     ! ascending order, so invert order if necessary:
     desc_lat = latitude(1) > latitude(n_lat)
@@ -209,5 +209,5 @@
        ! We average with respect to sine of latitude, which is
        ! equivalent to weighting by cosine of latitude:
-       call regr1_conserv(o3_par_in, xs = sin(lat_in_edg), &
+       call regr_conserv(1, o3_par_in, xs = sin(lat_in_edg), &
             xt = (/-1., sin((/boundslat_reg(nbp_lat-1:1:-1,south)/)), 1./), &
             vt = v_regr_lat(nbp_lat:1:-1, :, 1:12))
@@ -221,5 +221,5 @@
 
        ! Regrid in time by linear interpolation:
-       o3_par_out = regr3_lint(v_regr_lat, tmidmonth, tmidday)
+       call regr_lint(3, v_regr_lat, tmidmonth, tmidday, o3_par_out)
 
        ! Write to file:
Index: LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 2839)
@@ -76,5 +76,5 @@
     use dimphy, only: klon
     use mod_phys_lmdz_mpi_data, only: is_mpi_root
-    use regr_pr_av_m, only: regr_pr_av
+    use regr_pr_time_av_m, only: regr_pr_time_av
     use regr_pr_int_m, only: regr_pr_int
     use press_coefoz_m, only: press_in_edg, plev
@@ -128,6 +128,6 @@
     !$omp end master
 
-    call regr_pr_av(ncid, (/"a2       ", "a4       ", "a6       ", &
-         "P_net_Mob", "r_Mob    ", "temp_Mob ", "R_Het    "/), julien, &
+    call regr_pr_time_av(ncid, (/"a2       ", "a4       ", "a6       ", &
+         "P_net_Mob", "r_Mob    ", "temp_Mob ", "R_Het    "/), REAL(julien-1), &
          press_in_edg, paprs, coefoz)
     a2 = coefoz(:, :, 1)
Index: LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90	(revision 2839)
@@ -28,5 +28,5 @@
     use netcdf, only: nf90_get_var
     use assert_m, only: assert
-    use regr1_lint_m, only: regr1_lint
+    use regr_lint_m, only: regr_lint
     use mod_phys_lmdz_mpi_data, only: is_mpi_root
     use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
@@ -97,5 +97,6 @@
     ! Regrid in pressure at each horizontal position:
     do i = 1, klon
-       v3(i, nbp_lev:1:-1) = regr1_lint(v2(i, :), (/0., plev/), pplay(i, nbp_lev:1:-1))
+       call regr_lint(1, v2(i, :), (/0., plev/), pplay(i, nbp_lev:1:-1), &
+                         v3(i, nbp_lev:1:-1))
        ! (invert order of indices because "pplay" is in descending order)
     end do
Index: LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2839)
@@ -28,5 +28,5 @@
     use netcdf, only:  nf90_nowrite, nf90_get_var
     use assert_m, only: assert
-    use regr1_conserv_m, only: regr1_conserv
+    use regr_conserv_m, only: regr_conserv
     use press_coefoz_m, only: press_in_edg
     use time_phylmdz_mod, only: day_ref
@@ -75,5 +75,5 @@
     ! Poles:
     do j = 1, nbp_lat, nbp_lat-1
-       call regr1_conserv(r_mob(j, :), press_in_edg, &
+       call regr_conserv(1, r_mob(j, :), press_in_edg, &
             p3d(1, j, nbp_lev + 1:1:-1), o3_mob_regr(1, j, nbp_lev:1:-1))
        ! (invert order of indices because "p3d" is in descending order)
@@ -83,5 +83,5 @@
     do j = 2, nbp_lat-1
        do i = 1, nbp_lon
-          call regr1_conserv(r_mob(j, :), press_in_edg, &
+          call regr_conserv(1, r_mob(j, :), press_in_edg, &
                p3d(i, j, nbp_lev + 1:1:-1), o3_mob_regr(i, j, nbp_lev:1:-1))
           ! (invert order of indices because "p3d" is in descending order)
Index: LMDZ5/branches/testing/libf/phylmd/regr_pr_time_av_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/regr_pr_time_av_m.F90	(revision 2839)
+++ LMDZ5/branches/testing/libf/phylmd/regr_pr_time_av_m.F90	(revision 2839)
@@ -0,0 +1,403 @@
+! $Id$
+MODULE regr_pr_time_av_m
+
+  USE print_control_mod, ONLY: lunout
+  USE write_field_phy
+  USE mod_phys_lmdz_transfert_para, ONLY: bcast
+  IMPLICIT NONE
+
+!-------------------------------------------------------------------------------
+! Purpose: Regrid pressure with an averaging method. Operations done:
+!  * on the root process: read a NetCDF 3D or 4D field at a given day.
+!  * pack the fields to the LMDZ "horizontal "physics" grid and scatter
+!    to all threads of all processes;
+!  * in all the threads of all the processes, regrid the fields in pressure
+!    to the LMDZ vertical grid.
+!  * input files fields are stretched in the viscinity (+/- 5 kms) of the mean
+!    tropopause (geometrical mean of LMDZ and input fields tropopauses) to force
+!    the resulting field tropopause height to the one of LMDZ. To switch this
+!    feature on, the following arguments must be present:
+!     - "lat_in":   input file latitudes.
+!     - "pcen_in":  input file cells center pressure levels.
+!     - "ptrop_ou": target grid (LMDZ) tropopause pressure.
+!    Note that the ozone quantity conservation is not ensured.
+!-------------------------------------------------------------------------------
+! Initial routine: regr_pr_av_m module (L. Guez).
+! Present version: David Cugnet ; corresponding additions:
+!    - time interpolation
+!    - 3D compliant
+!    - vertical stretching of the field to allow tropopause and ground pressure
+!      matching between input field and current lmdz field.
+!-------------------------------------------------------------------------------
+! Remarks:
+!  * 3D fields are zonal means, with dimensions (latitude, pressure, julian day)
+!  * 4D fields have the dimensions:  (longitude, latitude, pressure, julian day)
+!  * All the fields are already on the horizontal grid (rlatu) or (rlatu,rlonv),
+!    except that the latitudes are in ascending order in the input file.
+!  * We assume that all the input fields have the same coordinates.
+!  * The target vertical LMDZ grid is the grid of layer boundaries.
+!  * Regridding in pressure is conservative, second order.
+!  * All the fields are regridded as a single multi-dimensional array, so it
+!    saves CPU time to call this procedure once for several NetCDF variables
+!    rather than several times, each time for a single NetCDF variable.
+!  * The input file pressure at tropopause can be (in decreasing priority):
+!    1) read from the file if "tropopause_air_pressure" field is available.
+!    2) computed from the input file ozone field using:
+!       - o3 concentration at tropopause if "tro3_at_tropopause" is available.
+!       - a default value (100ppbv) if not.
+!  * If available, the field "ps" (input file pressure at surface) is used.
+!    If not, the current LMDZ ground pressure is taken instead.
+!  * The O3 threshold for tropopause is defined using 3 coefficients:
+!    o3t(ppbV)=co1+co2*SIN(PI*(month-2)/6)*TANH(lat_deg/c)
+!     => co1 and co2 are in ppmV, and co3 in degrees.
+!     => co3 allow a smooth transition between north and south hemispheres.
+!-------------------------------------------------------------------------------
+! * Fields with suffix "m"/"p" are at the closest records earlier/later than the
+!   middle of the julian day "julien", on the global "dynamics" horizontal grid.
+! * Fields(i,j,k,l) are at longitude-latitude "rlonv(i)-rlatu(j)", pressure
+!   interval "pint_in(k:k+1)]" and variable "nam(l)".
+! * In the 2D file case, the values are the same for all longitudes.
+! * The following fields are on the global "dynamics" grid, as read from files:
+  REAL,    SAVE, ALLOCATABLE :: v1m(:,:,:,:)       !--- Previous ozone fields
+  REAL,    SAVE, ALLOCATABLE :: v1p(:,:,:,:)       !--- Next ozone fields
+  REAL,    SAVE, ALLOCATABLE :: psm(:,:), psp(:,:) !--- Surface pressure
+  REAL,    SAVE, ALLOCATABLE :: ptm(:,:), ptp(:,:) !--- Tropopause pressure
+  REAL,    SAVE, ALLOCATABLE :: otm(:,:), otp(:,:) !--- Tropopause o3 mix. ratio
+  INTEGER, SAVE :: irec                            !--- Current time index
+!      * for daily   input files: current julian day number
+!      * for monthly input files: julien is in [time_in(irec),time_in(irec+1)]
+  LOGICAL, SAVE :: linterp                         !--- Interpolation in time
+  LOGICAL, SAVE :: lPrSurf                         !--- Surface pressure flag
+  LOGICAL, SAVE :: lPrTrop                         !--- Tropopause pressure flag
+  LOGICAL, SAVE :: lO3Trop                         !--- Tropopause ozone flag
+  LOGICAL, SAVE :: lfirst=.TRUE.                   !--- First call flag
+!$OMP THREADPRIVATE(lfirst)
+  REAL, PARAMETER :: co3(3)=[91.,28.,20.]          !--- Coeffs for o3 threshold
+  REAL, PARAMETER :: prtrop=5.E+3  !--- Value lower than the tropopause pressure
+  REAL, PARAMETER :: delta =5.     !--- Dist. around tropopause for strain (kms)
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE regr_pr_time_av(fID, nam, julien, pint_in, pint_ou, v3, time_in,    &
+                                     lat_in, pcen_in, ptrop_ou)
+!
+!-------------------------------------------------------------------------------
+  USE dimphy,         ONLY: klon
+  USE netcdf95,       ONLY: NF95_INQ_VARID, NF95_INQUIRE_VARIABLE, handle_err
+  USE netcdf,         ONLY: NF90_INQ_VARID, NF90_GET_VAR, NF90_NOERR
+  USE assert_m,       ONLY: assert
+  USE assert_eq_m,    ONLY: assert_eq
+  USE comvert_mod,    ONLY: scaleheight
+  USE interpolation,  ONLY: locate
+  USE regr_conserv_m, ONLY: regr_conserv
+  USE regr_lint_m,    ONLY: regr_lint
+  USE slopes_m,       ONLY: slopes
+  USE mod_phys_lmdz_mpi_data,       ONLY: is_mpi_root
+  USE mod_grid_phy_lmdz,            ONLY: nbp_lon, nbp_lat, nbp_lev
+  USE mod_phys_lmdz_transfert_para, ONLY: scatter2d, scatter
+  USE phys_cal_mod,                 ONLY: calend, year_len, days_elapsed, jH_cur
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER, INTENT(IN)  :: fID           !--- NetCDF file ID
+  CHARACTER(LEN=13), INTENT(IN) :: nam(:)     !--- NetCDF variables names
+  REAL,    INTENT(IN)  :: julien        !--- Days since Jan 1st
+  REAL,    INTENT(IN)  :: pint_in(:)    !--- Interfaces file Pres, Pa, ascending
+  REAL,    INTENT(IN)  :: pint_ou(:,:)  !--- Interfaces LMDZ Pres, Pa (klon,llm+1)
+  REAL,    INTENT(OUT) :: v3(:,:,:)     !--- Regridded field (klon,llm,SIZE(nam))
+  REAL,    INTENT(IN), OPTIONAL :: time_in(:) !--- Records times, in days
+                                              !    since Jan 1 of current year
+  REAL,    INTENT(IN), OPTIONAL :: lat_in(:)  !--- Input/output latitudes vector
+  REAL,    INTENT(IN), OPTIONAL :: pcen_in(:) !--- Mid-layers file pressure
+  REAL,    INTENT(IN), OPTIONAL :: ptrop_ou(:)!--- Output tropopause pressure (klon)
+!-------------------------------------------------------------------------------
+! Local variables:
+  include "clesphys.h"
+  include "YOMCST.h"
+  CHARACTER(LEN=80)  :: sub
+  CHARACTER(LEN=320) :: msg
+  INTEGER :: vID, ncerr, n_var, nlev_in,ntim_in, ndim, i, ibot, itop, itrp,itrp0
+  LOGICAL :: lAdjTro                          !--- Need to adjust tropopause
+  REAL    :: y_frac                           !--- Elapsed year fraction
+  REAL    :: alpha, beta, al                  !--- For strectching/interpolation
+  REAL    :: SigT_in, SigT_ou, SigT_mn        !--- Tropopause: in/out/mean
+  REAL    :: SigA_bot, SigA_top               !--- Strained domain bounds
+  REAL    :: Sig_in (SIZE(pint_in))           !--- Input field sigma levels
+  REAL    :: phi    (SIZE(pint_in))           !--- Stretching exponent anomaly
+  REAl    :: Pint_st(SIZE(pint_in))           !--- Stretched pressure levels
+  REAL    :: v1(nbp_lon,nbp_lat,SIZE(pint_in)-1,SIZE(nam))
+  REAL    :: v2(klon,           SIZE(pint_in)-1,SIZE(nam))
+! v1: Field read/interpol at time "julien" on the global "dynamics" horiz. grid.
+! v2: Field scattered to the partial "physics" horizontal grid.
+!     In the 2D file case, the values are the same for all longitudes.
+!     "v2(i,    k, l)" is at longitude-latitude  "xlon(i)-xlat(i)".
+! Both are for pressure interval "press_in_edg(k:k+1)]" and variable "nam(l)"
+  REAL, DIMENSION(nbp_lon, nbp_lat) ::  ps1, pt1, ot1
+  REAL, DIMENSION(klon)             ::  ps2, pt2, ot2
+!-------------------------------------------------------------------------------
+  sub="regr_pr_time_av"
+  nlev_in=SIZE(pint_in)-1; ntim_in=SIZE(time_in)
+  CALL assert(SIZE(v3,1)==klon,                 TRIM(sub)//" v3 klon")
+  CALL assert(SIZE(v3,2)==nbp_lev,              TRIM(sub)//" v3 nbp_lev")
+  n_var = assert_eq(SIZE(nam), SIZE(v3,3),      TRIM(sub)//" v3 n_var")
+  CALL assert(SHAPE(pint_ou)==[klon, nbp_lev+1],TRIM(sub)//" pint_ou")
+  IF(PRESENT(lat_in))   CALL assert(SIZE(lat_in  )==klon,TRIM(sub)//" lat_in klon")
+  IF(PRESENT(ptrop_ou)) CALL assert(SIZE(ptrop_ou)==klon,TRIM(sub)//" ptrop_ou klon")
+  IF(PRESENT(pcen_in))  CALL assert(SIZE(pcen_in)==nlev_in,TRIM(sub)//" pcen_in")
+  lAdjTro=PRESENT(ptrop_ou)
+  IF(lAdjTro.AND.(.NOT.PRESENT(lat_in).OR..NOT.PRESENT(pcen_in))) &
+  CALL abort_physic(sub, 'Missing lat_in and/or pcen_in (adjust_tropopause=T)', 1)
+
+  !$OMP MASTER
+  IF(is_mpi_root) THEN
+
+    !=== CHECK WHICH FIELDS ARE AVAILABLE IN THE INPUT FILE
+    IF(lfirst) THEN
+      lPrSurf=NF90_INQ_VARID(fID,"ps"                     ,vID)==NF90_NOERR
+      lPrTrop=NF90_INQ_VARID(fID,"tropopause_air_pressure",vID)==NF90_NOERR
+      lO3Trop=NF90_INQ_VARID(fID,"tro3_at_tropopause"     ,vID)==NF90_NOERR
+      linterp=PRESENT(time_in); IF(linterp) linterp=ntim_in==14
+      IF(linterp) THEN
+        ALLOCATE(v1m(nbp_lon,nbp_lat,nlev_in,n_var))
+        ALLOCATE(v1p(nbp_lon,nbp_lat,nlev_in,n_var))
+        ALLOCATE(psm(nbp_lon,nbp_lat),psp(nbp_lon,nbp_lat))
+        ALLOCATE(ptm(nbp_lon,nbp_lat),ptp(nbp_lon,nbp_lat))
+        IF(lO3Trop) ALLOCATE(otm(nbp_lon,nbp_lat),otp(nbp_lon,nbp_lat))
+      END IF
+      !--- INITIAL INDEX: LOCATE A LAYER WELL ABOVE TROPOPAUSE (50hPa)
+      IF(lAdjTro) itrp0=locate(pcen_in,prtrop)
+      IF(lPrSurf) WRITE(lunout,*)TRIM(sub)//': Using GROUND PRESSURE from input O3 forcing file.'
+      IF(linterp) WRITE(lunout,*)TRIM(sub)//': Monthly O3 files => ONLINE TIME INTERPOLATION.'
+      IF(lAdjTro) THEN
+        WRITE(lunout,*)TRIM(sub)//': o3 forcing file tropopause location uses:'
+        IF(lPrTrop) THEN
+          WRITE(lunout,*)'    PRESSURE AT TROPOPAUSE from file.'
+        ELSE IF(lO3Trop) THEN
+          WRITE(lunout,*)'    O3 CONCENTRATION AT TROPOPAUSE from file.'
+        ELSE
+          WRITE(lunout,*)'    PARAMETRIZED O3 concentration at tropopause.'
+        END IF
+      END IF
+    END IF
+
+    !=== UPDATE (ALWAYS FOR DAILY FILES, EACH MONTH FOR MONTHLY FILES)
+    CALL update_fields()
+
+
+    !=== TIME INTERPOLATION FOR MONTHLY INPUT FILES
+    IF(linterp) THEN
+      WRITE(lunout,'(3(a,f7.3))')TRIM(sub)//': Interpolating O3 at julian day '&
+      &,julien,' from fields at times ',time_in(irec),' and ', time_in(irec+1)
+      al=(time_in(irec+1)-julien)/(time_in(irec+1)-time_in(irec))
+      v1=al*v1m+(1.-al)*v1p
+      IF(lPrSurf) ps1=al*psm+(1.-al)*psp
+      IF(lPrTrop) pt1=al*ptm+(1.-al)*ptp
+      IF(lO3Trop) ot1=al*otm+(1.-al)*otp
+    END IF
+  END IF
+  !$OMP END MASTER
+  IF(lfirst) THEN
+    lfirst=.FALSE. ;     CALL bcast(lfirst) ; CALL bcast(lPrSurf)
+    CALL bcast(lPrTrop); CALL bcast(lO3Trop); CALL bcast(linterp)
+    IF(lAdjTro) CALL bcast(itrp0)
+  END IF
+  CALL scatter2d(v1,v2)
+  !--- No "ps" in input file => assumed to be equal to current LMDZ ground press
+  IF(lPrSurf) THEN; CALL scatter2d(ps1,ps2); ELSE; ps2=Pint_ou(:,1); END IF
+  IF(lPrTrop) CALL scatter2d(pt1,pt2)
+  IF(lO3Trop) CALL scatter2d(ot1,ot2)
+
+  !--- REGRID IN PRESSURE ; 3rd index inverted because "paprs" is decreasing
+  IF(.NOT.lAdjTro) THEN
+    DO i=1,klon
+      CALL regr_conserv(1,v2(i,:,:) , Pint_in , Pint_ou(i,nbp_lev+1:1:-1),    &
+                          v3(i,nbp_lev:1:-1,:), slopes(1,v2(i,:,:),pint_in))
+    END DO
+  ELSE
+    y_frac=(REAL(days_elapsed)+jH_cur)/year_len
+    DO i=1,klon
+      SigT_in = get_SigTrop(i,itrp)        !--- input  (file) tropopause
+      SigT_ou = ptrop_ou(i)/pint_ou(i,1)   !--- output (lmdz) tropopause
+      SigT_mn = SQRT(SigT_in*SigT_ou)      !--- mean tropopause>strained domain
+
+      !--- DEFINE THE VERTICAL LAYER IN WHICH THE PROFILE IS STRECHED
+      beta=EXP(delta/scaleheight); Sig_in(:) = [pint_in(1:nlev_in)/ps2(i),1.]
+      SigA_bot = SigT_mn*beta ; ibot=locate(Sig_in(:),SigA_bot)
+      SigA_top = SigT_mn/beta ; itop=locate(Sig_in(:),SigA_top)+1
+
+      !--- HAT FUNCTION phi (/=0 in [SigA_bot,SigA_top] only)
+      phi(:)=0.
+      phi(itop:itrp)=(Sig_in(itop:itrp)-SigA_top)/(SigT_in-SigA_top)
+      phi(itrp:ibot)=(SigA_bot-Sig_in(itrp:ibot))/(SigA_bot-SigT_in)
+
+      !--- STRAINED INPUT logP PROFILE ; alpha: MAX. STRETCH. EXPONENT INCREMENT
+      alpha = LOG(SigT_ou/SigT_in)/LOG(SigT_in)
+      Pint_st(:) = pint_ou(i,1) * Sig_in(:)**(1+alpha*phi(:))
+
+      !--- REGRID INPUT PROFILE ON STRAINED VERTICAL LEVELS
+      CALL regr_conserv(1,v2(i,:,:) , Pint_st,  Pint_ou(i,nbp_lev+1:1:-1),     &
+                          v3(i,nbp_lev:1:-1,:), slopes(1,v2(i,:,:),Pint_st))
+    END DO
+  END IF
+
+
+CONTAINS
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE update_fields()
+!
+!-------------------------------------------------------------------------------
+  IF(.NOT.linterp) THEN                 !=== DAILY FILES: NO TIME INTERPOLATION
+    WRITE(lunout,*)TRIM(sub)//': Updating Ozone forcing field: read from file.'
+    irec=MIN(INT(julien)+1,ntim_in)     !--- irec is just the julian day number
+    !--- MIN -> Security in the unlikely case of roundup errors.
+    CALL get_3Dfields(v1)               !--- Read ozone field(s)
+    IF(lAdjTro) THEN                    !--- Additional files for fields strain
+      IF(lPrSurf) CALL get_2Dfield(ps1,"ps")
+      IF(lPrTrop) CALL get_2Dfield(pt1,"tropopause_air_pressure")
+      IF(lO3Trop) CALL get_2Dfield(ot1,"tro3_at_tropopause")
+    END IF
+  ELSE                                  !=== MONTHLY FILES: GET 2 NEAREST RECS
+    IF(.NOT.lfirst.AND.julien<time_in(irec+1)) RETURN
+    WRITE(lunout,*)TRIM(sub)//': Refreshing adjacent Ozone forcing fields.'
+    IF(lfirst) THEN                     !=== READ EARLIEST TIME FIELDS
+      irec=locate(time_in,julien)       !--- Need to locate surrounding times
+      CALL get_3Dfields(v1m)            !--- Read ozone field(s)
+      IF(lAdjTro) THEN                  !--- Additional files for fields strain
+        IF(lPrSurf) CALL get_2Dfield(psm,"ps")
+        IF(lPrTrop) CALL get_2Dfield(ptm,"tropopause_air_pressure")
+        IF(lO3Trop) CALL get_2Dfield(otm,"tro3_at_tropopause")
+      END IF
+    ELSE                                !=== SHIFT FIELDS
+      v1m=v1p                           !--- Ozone fields
+      IF(lAdjTro) THEN                  !--- Additional files for fields strain
+        IF(lPrSurf) psm=psp             !--- Surface pressure
+        IF(lPrTrop) ptm=ptp             !--- Tropopause pressure
+        IF(lO3Trop) otm=otp             !--- Tropopause ozone
+      END IF
+    END IF
+    irec=irec+1
+    CALL get_3Dfields(v1p)              !--- Read ozone field(s)
+    IF(lAdjTro) THEN                    !--- Additional files for fields strain
+      IF(lPrSurf) CALL get_2Dfield(psp,"ps")
+      IF(lPrTrop) CALL get_2Dfield(ptp,"tropopause_air_pressure")
+      IF(lO3Trop) CALL get_2Dfield(otp,"tro3_at_tropopause")
+    END IF
+    IF(lfirst) irec=irec-1
+  END IF
+
+END SUBROUTINE update_fields
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE get_2Dfield(v,var)
+!
+!-------------------------------------------------------------------------------
+! Purpose: Shortcut to get the "irec"th record of the surface field named "var"
+!          from the input file.
+! Remark: In case the field is zonal, it is duplicated along first dimension.
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL,             INTENT(INOUT) :: v(:,:)
+  CHARACTER(LEN=*), INTENT(IN)    :: var
+!-------------------------------------------------------------------------------
+  CALL NF95_INQ_VARID(fID, TRIM(var), vID)
+  CALL NF95_INQUIRE_VARIABLE(fID, vID, ndims=ndim)
+  IF(ndim==2) ncerr=NF90_GET_VAR(fID,vID,v(1,:), start=[  1,irec])
+  IF(ndim==3) ncerr=NF90_GET_VAR(fID,vID,v(:,:), start=[1,1,irec])
+  CALL handle_err(TRIM(sub)//" NF90_GET_VAR "//TRIM(var),ncerr,fID)
+
+  !--- Flip latitudes: ascending in input file, descending in "rlatu".
+  IF(ndim==3) THEN
+    v(1,:) = v(1,nbp_lat:1:-1)
+    v(2:,:)= SPREAD(v(1,:),DIM=1,ncopies=nbp_lon-1)  !--- Duplication
+  ELSE
+    v(:,:) = v(:,nbp_lat:1:-1)
+  END IF
+
+END SUBROUTINE get_2Dfield
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE get_3Dfields(v)
+!
+!-------------------------------------------------------------------------------
+! Purpose: Shortcut to get the "irec"th record of the 3D fields named "nam"
+!          from the input file. Fields are stacked on fourth dimension.
+! Remark: In case the field is zonal, it is duplicated along first dimension.
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(INOUT) :: v(:,:,:,:)
+!-------------------------------------------------------------------------------
+  DO i=1,SIZE(nam)
+    CALL NF95_INQ_VARID(fID, TRIM(nam(i)), vID)
+    CALL NF95_INQUIRE_VARIABLE(fID, vID, ndims=ndim)
+    IF(ndim==3) ncerr=NF90_GET_VAR(fID,vID,v(1,:,:,i), start=[  1,1,irec])
+    IF(ndim==4) ncerr=NF90_GET_VAR(fID,vID,v(:,:,:,i), start=[1,1,1,irec])
+    CALL handle_err(TRIM(sub)//" NF90_GET_VAR "//TRIM(nam(i)),ncerr,fID)
+  END DO
+
+  !--- Flip latitudes: ascending in input file, descending in "rlatu".
+  IF(ndim==3) THEN
+    v(1,:,:,:) = v(1,nbp_lat:1:-1,:,:)
+    v(2:,:,:,:)= SPREAD(v(1,:,:,:),DIM=1,ncopies=nbp_lon-1)  !--- Duplication
+  ELSE
+    v(:,:,:,:) = v(:,nbp_lat:1:-1,:,:)
+  END IF
+
+END SUBROUTINE get_3Dfields
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
+FUNCTION get_SigTrop(ih,it)
+!
+!-------------------------------------------------------------------------------
+! Arguments:
+  INTEGER, INTENT(IN)  :: ih
+  INTEGER, INTENT(OUT) :: it
+  REAL                 :: get_Sigtrop
+!-------------------------------------------------------------------------------
+! Local variables:
+  INTEGER :: ii                                !--- Idx of layer containing o3t
+  REAL    :: o3t                               !--- Ozone concent. at tropopause
+  REAL    :: prt                               !--- Air pressure   at tropopause
+  REAL    :: al                                !--- Interpolation coefficient
+  REAL    :: coef                              !--- Coef: North/South transition
+!-------------------------------------------------------------------------------
+  !--- DETERMINE PRESSURE AT TROPOPAUSE AND DIVIDE IT BY GROUND PRESSURE
+  IF(lPrTrop) THEN                             !--- PrTrop KNOWN FROM FILE
+    get_SigTrop=pt2(ih)/ps2(ih)
+    it=locate(pint_in(:),pt2(ih))
+  ELSE                                         !--- O3 THRESHOLD
+    coef = TANH(lat_in(i)/co3(3))              !--- Latitude dependant ponderat.
+    coef = SIN (2.*RPI*(y_frac-1./6.)) * coef  !--- Time-dependant ponderation
+    o3t  = 1.E-9 * (co3(1)+co3(2)*coef)        !--- Value from parametrization
+    IF(lO3Trop) o3t=ot2(ih)                    !--- Value from file
+    !--- Starts from 50hPa and go down.
+    it=itrp0; DO WHILE(v2(ih,it+1,1)>=o3t); it=it+1; END DO
+    al=(v2(ih,it,1)-o3t)/(v2(ih,it,1)-v2(ih,it+1,1))
+    get_SigTrop = ( pcen_in(it)**(1.-al) * pcen_in(it+1)**al )/ps2(ih)
+  END IF
+
+END FUNCTION get_SigTrop
+!
+!-------------------------------------------------------------------------------
+
+
+END SUBROUTINE regr_pr_time_av
+!
+!-------------------------------------------------------------------------------
+
+END MODULE regr_pr_time_av_m
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2839)
@@ -12,5 +12,5 @@
   USE DIMPHY
   USE aero_mod
-  USE phys_local_var_mod, ONLY: od550aer,od865aer,ec550aer,od550lt1aer
+  USE phys_local_var_mod, ONLY: od443aer,od550aer,od865aer,ec550aer,od550lt1aer
   USE YOMCST, ONLY: RD,RG
 
@@ -327,5 +327,6 @@
         soluble=.TRUE.
         spsol=4
-        fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for AOD
+        !fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for AOD
+        fac=0.0      !--6 March 2017 - OB as Didier H said CSSO4 should not be used
     ELSEIF (aerosol_name(m).EQ.id_SSSSM_phy) THEN 
         soluble=.TRUE.
@@ -366,6 +367,8 @@
     DO la=1,las
 
-    !--only 550, 670 and 865 nm are used
-    IF (la.NE.la550.AND.la.NE.la670.AND.la.NE.la865) CYCLE
+    !--only 443, 550, 670 and 865 nm are used
+    !--to save time 670 and AI are not computed for CMIP6
+    !IF (la.NE.la443.AND.la.NE.la550.AND.la.NE.la670.AND.la.NE.la865) CYCLE
+    IF (la.NE.la443.AND.la.NE.la550.AND.la.NE.la865) CYCLE
 
       IF (soluble) THEN            ! For soluble aerosol
@@ -433,6 +436,7 @@
 
 !--AOD calculations for diagnostics
+  od443aer(:)=SUM(tausum(:,la443,:),dim=2)
   od550aer(:)=SUM(tausum(:,la550,:),dim=2)
-  od670aer(:)=SUM(tausum(:,la670,:),dim=2)
+  !od670aer(:)=SUM(tausum(:,la670,:),dim=2)
   od865aer(:)=SUM(tausum(:,la865,:),dim=2)
 
@@ -441,5 +445,6 @@
 
 !--aerosol index
-  ai(:)=-LOG(MAX(od670aer(:),1.e-8)/MAX(od865aer(:),1.e-8))/LOG(670./865.)
+  ai(:)=0.0
+  !ai(:)=-LOG(MAX(od670aer(:),1.e-8)/MAX(od865aer(:),1.e-8))/LOG(670./865.)
 
   od550lt1aer(:)=tausum(:,la550,id_ASSO4M_phy)+tausum(:,la550,id_ASBCM_phy) +tausum(:,la550,id_AIBCM_phy)+ &
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2839)
@@ -566,5 +566,6 @@
         soluble=.TRUE.
         spsol=3
-        fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for AOD
+        !fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for AOD
+        fac=0.0      !--6 March 2017 - OB as Didier H said CSSO4 should not be used
      ELSEIF  (aerosol_name(m).EQ.id_ASSO4M_phy) THEN
         soluble=.TRUE.
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/read_rsun_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/read_rsun_rrtm.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/read_rsun_rrtm.F90	(revision 2839)
@@ -10,5 +10,5 @@
   USE netcdf, ONLY: nf90_get_var, nf90_noerr, nf90_nowrite
 
-  USE phys_cal_mod, ONLY : day_cur, year_len
+  USE phys_cal_mod, ONLY : days_elapsed, year_len
 
   USE mod_phys_lmdz_mpi_data, ONLY: is_mpi_root
@@ -23,10 +23,10 @@
 
   ! Input arguments
-  LOGICAL, INTENT(IN)          :: debut
+  LOGICAL, INTENT(IN) :: debut
 
 ! Local variables
-  INTEGER               :: ncid, dimid, varid, ncerr, nbday
+  INTEGER :: ncid, dimid, varid, ncerr, nbday
   REAL, POINTER :: wlen(:), time(:)
-  REAL, ALLOCATABLE, SAVE, DIMENSION(:,:)   :: SSI_FRAC
+  REAL, ALLOCATABLE, SAVE, DIMENSION(:,:) :: SSI_FRAC
 !$OMP THREADPRIVATE(SSI_FRAC)
   REAL, ALLOCATABLE, SAVE, DIMENSION(:) :: TSI(:)
@@ -90,15 +90,16 @@
     ENDIF
 
-!--only read at beginning of month
-    IF (debut.OR.day_cur.NE.day_pre) THEN
+!--only read at beginning of day
+!--day in year is provided as days_elapsed since the beginning of the year +1
+    IF (debut.OR.days_elapsed+1.NE.day_pre) THEN
 
-!--keep memory of previous month
-      day_pre=day_cur
+!--keep memory of previous day
+      day_pre=days_elapsed+1
 
 !--copy 
-      RSUN(1:NSW)=SSI_FRAC(:,day_cur)
-      solaire=TSI(day_cur)
+      RSUN(1:NSW)=SSI_FRAC(:,days_elapsed+1)
+      solaire=TSI(days_elapsed+1)
 
-      print *,'READ_RSUN_RRTM day=', day_cur,' solaire=', solaire, ' RSUN=', RSUN(1:NSW)
+      print *,'READ_RSUN_RRTM day=', days_elapsed+1,' solaire=', solaire, ' RSUN=', RSUN(1:NSW)
 
     ENDIF !--fin allocation
